;;
;; WCRT  -  Win32API CRT
;;
;; wcrt.inc
;;
;; Copyright (c) 2003-2005 by Joergen Ibsen / Jibz
;; All Rights Reserved
;;
;; http://www.ibsensoftware.com/
;;
;; This software is provided 'as-is', without any express
;; or implied warranty.  In no event will the authors be
;; held liable for any damages arising from the use of
;; this software.
;;
;; Permission is granted to anyone to use this software
;; for any purpose, including commercial applications,
;; and to alter it and redistribute it freely, subject to
;; the following restrictions:
;;
;; 1. The origin of this software must not be
;;    misrepresented; you must not claim that you
;;    wrote the original software. If you use this
;;    software in a product, an acknowledgment in
;;    the product documentation would be appreciated
;;    but is not required.
;;
;; 2. Altered source versions must be plainly marked
;;    as such, and must not be misrepresented as
;;    being the original software.
;;
;; 3. This notice may not be removed or altered from
;;    any source distribution.
;;

ifndef WCRT_INC_INCLUDED
WCRT_INC_INCLUDED = 1

    ; math.h

    sin     PROTO C :REAL8
    cos     PROTO C :REAL8
    tan     PROTO C :REAL8
    asin    PROTO C :REAL8
    acos    PROTO C :REAL8
    atan    PROTO C :REAL8
    atan2   PROTO C :REAL8,:REAL8
    sinh    PROTO C :REAL8
    cosh    PROTO C :REAL8
    tanh    PROTO C :REAL8
    exp     PROTO C :REAL8
    exp2    PROTO C :REAL8
    log     PROTO C :REAL8
    log10   PROTO C :REAL8
    log2    PROTO C :REAL8
    pow     PROTO C :REAL8,:REAL8

    sqrt    PROTO C :REAL8
    ceil    PROTO C :REAL8
    floor   PROTO C :REAL8
    round   PROTO C :REAL8
    fabs__  PROTO C :REAL8
    ldexp   PROTO C :REAL8,:SDWORD

    sinf    PROTO C :REAL4
    cosf    PROTO C :REAL4
    tanf    PROTO C :REAL4
    asinf   PROTO C :REAL4
    acosf   PROTO C :REAL4
    atanf   PROTO C :REAL4
    atan2f  PROTO C :REAL4,:REAL4
    sinhf   PROTO C :REAL4
    coshf   PROTO C :REAL4
    tanhf   PROTO C :REAL4
    expf    PROTO C :REAL4
    exp2f   PROTO C :REAL4
    logf    PROTO C :REAL4
    log10f  PROTO C :REAL4
    log2f   PROTO C :REAL4
    powf    PROTO C :REAL4,:REAL4

    sqrtf   PROTO C :REAL4
    ceilf   PROTO C :REAL4
    floorf  PROTO C :REAL4
    roundf  PROTO C :REAL4
    fabsf   PROTO C :REAL4
    ldexpf  PROTO C :REAL4,:SDWORD

    ; stdio.h

    EOF     equ (-1)

    FILENAME_MAX equ 260

    extern wcrt_stdin:DWORD
    extern wcrt_stdout:DWORD
    extern wcrt_stderr:DWORD

    stdin  equ <wcrt_stdin>
    stdout equ <wcrt_stdout>
    stderr equ <wcrt_stderr>

    SEEK_SET equ 0
    SEEK_CUR equ 1
    SEEK_END equ 2

    L_tmpnam equ 16
    TMP_MAX  equ 32767

    freopen PROTO C :DWORD,:DWORD,:DWORD
    fopen   PROTO C :DWORD,:DWORD
    fflush  PROTO C :DWORD
    fclose  PROTO C :DWORD

    remove  PROTO C :DWORD
    rename  PROTO C :DWORD,:DWORD

    tmpnam  PROTO C :DWORD

    fprintf PROTO C :DWORD,:DWORD,:VARARG
    printf  PROTO C :DWORD,:VARARG
    sprintf PROTO C :DWORD,:DWORD,:VARARG
    snprintf PROTO C :DWORD,:DWORD,:DWORD,:VARARG

    vfprintf PROTO C :DWORD,:DWORD,:DWORD
    vprintf PROTO C :DWORD,:DWORD
    vsprintf PROTO C :DWORD,:DWORD,:DWORD
    vsnprintf PROTO C :DWORD,:DWORD,:DWORD,:DWORD

    fscanf  PROTO C :DWORD,:DWORD,:VARARG
    scanf   PROTO C :DWORD,:VARARG
    sscanf  PROTO C :DWORD,:DWORD,:VARARG

    fgetc   PROTO C :DWORD
    fgets   PROTO C :DWORD,:SDWORD,:DWORD

    fputc   PROTO C :SDWORD,:DWORD
    fputs   PROTO C :DWORD,:DWORD

    getc equ <fgetc>

;    #define getchar()  getc(stdin)

    gets    PROTO C :DWORD

    putc equ <fputc>

;    #define putchar(c) putc(c,stdout)

    puts    PROTO C :DWORD

    ungetc  PROTO C :SDWORD,:DWORD

    fread   PROTO C :DWORD,:DWORD,:DWORD,:DWORD
    fwrite  PROTO C :DWORD,:DWORD,:DWORD,:DWORD

    fseek   PROTO C :DWORD,:SDWORD,:SDWORD
    ftell   PROTO C :DWORD
    rewind  PROTO C :DWORD

    fgetpos PROTO C :DWORD,:DWORD
    fsetpos PROTO C :DWORD,:DWORD

    ; stdlib.h

    RAND_MAX equ 07fffh

    atof    PROTO C :DWORD
    atoi    PROTO C :DWORD
    atol    PROTO C :DWORD

    strtod  PROTO C :DWORD,:DWORD
    strtol  PROTO C :DWORD,:DWORD,:SDWORD
    strtoul PROTO C :DWORD,:DWORD,:SDWORD

    rand    PROTO C
    srand   PROTO C :DWORD

    calloc  PROTO C :DWORD,:DWORD
    malloc  PROTO C :DWORD
    realloc PROTO C :DWORD,:DWORD
    free    PROTO C :DWORD

    abort   PROTO C
    exit    PROTO C :DWORD
    atexit  PROTO C :DWORD

    getenv  PROTO C :DWORD

    bsearch PROTO C :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

    qsort   PROTO C :DWORD,:DWORD,:DWORD,:DWORD

    rand_r  PROTO C :DWORD

    rans_s  PROTO C

    ; string.h

    strcpy  PROTO C :DWORD,:DWORD
    strncpy PROTO C :DWORD,:DWORD,:DWORD
    strcat  PROTO C :DWORD,:DWORD
    strncat PROTO C :DWORD,:DWORD,:DWORD
    strcmp  PROTO C :DWORD,:DWORD
    strncmp PROTO C :DWORD,:DWORD,:DWORD
    strcoll PROTO C :DWORD,:DWORD
    strchr  PROTO C :DWORD,:SDWORD
    strrchr PROTO C :DWORD,:SDWORD
    strspn  PROTO C :DWORD,:DWORD
    strcspn PROTO C :DWORD,:DWORD
    strpbrk PROTO C :DWORD,:DWORD
    strstr  PROTO C :DWORD,:DWORD
    strlen  PROTO C :DWORD

    strtok  PROTO C :DWORD,:DWORD

    memcpy  PROTO C :DWORD,:DWORD,:DWORD
    memmove PROTO C :DWORD,:DWORD,:DWORD
    memcmp  PROTO C :DWORD,:DWORD,:DWORD
    memchr  PROTO C :DWORD,:SDWORD,:DWORD
    memset  PROTO C :DWORD,:SDWORD,:DWORD

    strlwr  PROTO C :DWORD
    strupr  PROTO C :DWORD
    stricmp PROTO C :DWORD,:DWORD
    strtok_r PROTO C :DWORD,:DWORD,:DWORD

endif


; additional by drizz
getchar macro
	exitm<invoke getc,addr stdin>
endm 
putchar macro chr:req
	exitm<invoke putc,chr,addr stdout>
endm 
T macro __qstr:VARARG
local __sym
.data
__sym db __qstr,0
.code
exitm <offset __sym>
endm
